//------------------------------------------------------------------------------
/* 
 * File:   main.c
 * Author: jge
 *
 * Created on 26 oktober 2012, 8:41
 */
//------------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
//------------------------------------------------------------------------------
//PRAGMA's

#pragma config  CPD =       OFF
#pragma config  BOREN =     OFF
#pragma config  IESO =      OFF
#pragma config  DEBUG =     OFF
#pragma config  FOSC =      INTRC_NOCLKOUT
#pragma config  FCMEN =     OFF
#pragma config  MCLRE =     ON
#pragma config  WDTE =      OFF
#pragma config  CP =        OFF
#pragma config  LVP =       OFF
#pragma config  PWRTE =     OFF
#pragma config  BOR4V =     BOR21V
#pragma config  WRT =       OFF

//------------------------------------------------------------------------------
//DEFINES

#define LD7     PORTCbits.RC7
#define LD6     PORTCbits.RC6
#define LD5     PORTCbits.RC5
#define LD4     PORTCbits.RC4

#define SW1     PORTAbits.RA4
#define SW2     PORTAbits.RA5
#define SW3     PORTAbits.RA6
#define SW4     PORTAbits.RA7

#define BLINKTIME   5000

//------------------------------------------------------------------------------
//DECLARATIONS

void init (void);
void button (void);
void blink (void);

unsigned int BlinkCounter;

//------------------------------------------------------------------------------
//CODE

//------------------------------------------------------------------------------
void main (void)
{

    init();
    while(1)
    {
        button();
        blink();
    }
}
//------------------------------------------------------------------------------
void button (void)
{

    if (SW1 == 1)
    {
        LD7 = 1;
    }
    else if (SW1 == 0)
    {
        LD7 = 0;
    }
}

//------------------------------------------------------------------------------
void blink (void)
{
    BlinkCounter++;

    if (BlinkCounter == BLINKTIME)
        {
            if (LD4 == 1)
            {
                LD4 = 0;
            }
            else if (LD4 == 0)
            {
                LD4 = 1;
            }
            BlinkCounter == 0;
        }
}

//------------------------------------------------------------------------------
void init(void)
{
    //OSC
    OSCCONbits.IRCF0 = 1;        // internal osc = 8Mhz
    OSCCONbits.IRCF1 = 1;
    OSCCONbits.IRCF2 = 1;
    OSCCONbits.OSTS = 1;        // osc is selected by FOSC (pragma)
    OSCCONbits.SCS = 0;         // clock source defined by FOSC (pragma)

    //PORTA
    PORTA = 0b00000000;         // clear PORTA
    ANSEL = 0b00000000;         // all pins are digital
    TRISA = 0b11111111;         // all pins are input

    //PORTB
    PORTB = 0b00000000;         // clear PORTB
    TRISB = 0b00000000;         // all pins are output (7 SEGMENT)
    WPUB = 0b00000000;          // weak pull-ups disabled
    IOCB = 0b00000000;          // interrupt on change disabled

    //PORTC
    PORTC = 0b00000000;         // clear PORTC
    TRISC = 0b00000000;         // all pins are output
    
    //INITS
    BlinkCounter == 0;
}

